IF EXISTS (SELECT * FROM dbo.SysObjects WHERE id = object_id(N'dbo.AUDIT_del_ReservationConferenceLine') AND OBJECTPROPERTY(id, N'IsTrigger') = 1) DROP TRIGGER dbo.AUDIT_del_ReservationConferenceLine 
GO
CREATE TRIGGER [dbo].[AUDIT_del_ReservationConferenceLine]
ON [dbo].[ReservationConferenceLine] FOR DELETE NOT FOR REPLICATION AS
BEGIN
	
	DECLARE 
		@IDENTITY_SAVE				varchar(50),
		@AUDIT_LOG_TRANSACTION_ID		Int,
		@PRIM_KEY				nvarchar(4000),
 		@ROWS_COUNT				int,
		@FK_UserIdNumber INT,
		@FK_CashBox INT,
		@ProgramPart SMALLINT,
		@TerminalName VARCHAR(50),
		@SystemDateStr VARCHAR(8),
		@SystemDateTime DATETIME

	SET NOCOUNT ON

	Select @ROWS_COUNT=count(*) from deleted
	Set @IDENTITY_SAVE = CAST(IsNull(@@IDENTITY,1) AS varchar(50))

    SELECT TOP 1 @FK_UserIdNumber = FK_UserIdNumber,
	@FK_CashBox = FK_CashBox,
	@ProgramPart = ProgramPart,
	@TerminalName = TerminalName
	FROM PersonnelLogInfo WITH (NOLOCK)
	WHERE spid = @@spid 
	ORDER BY CreateDate DESC

	IF ISNULL(@FK_UserIdNumber, 0) = 0
	  SET @FK_UserIdNumber = 1
	IF ISNULL(@FK_CashBox, -1) <= 0
	  SET @FK_CashBox = -1
	IF ISNULL(@ProgramPart, -1) <= 0
	  SET @ProgramPart = 14 -- ppUnknown from SystemAll
	IF ISNULL(@TerminalName, '') = ''
	  SET @TerminalName = 'Unknown'

    SELECT @SystemDateStr = SystemDate FROM System WITH (NOLOCK) WHERE Number = 1
    SET @SystemDateTime = CONVERT(DATETIME, @SystemDateStr + ' ' + CONVERT(CHAR(8), CURRENT_TIMESTAMP, 108))

	INSERT INTO dbo.AUDIT_LOG_TRANSACTIONS
	(
		TABLE_NAME,
		TABLE_SCHEMA,
		AUDIT_ACTION_ID,
		HOST_NAME,
		APP_NAME,
		MODIFIED_BY,
		MODIFIED_DATE,
		AFFECTED_ROWS,
		FK_UserIdNumber,
		FK_CashBox,
		ProgramPart,
		TerminalName,
		RealDateTime
	)
	values(
		'ReservationConferenceLine',
		'dbo',
		3,	--	ACTION ID For DELETE
		CASE 
		  WHEN LEN(HOST_NAME()) < 1 THEN ' '
		  ELSE HOST_NAME()
		END,
		CASE 
		  WHEN LEN(APP_NAME()) < 1 THEN ' '
		  ELSE APP_NAME()
		END,
		SUSER_SNAME(),
		@SystemDateTime,
		@ROWS_COUNT,
		@FK_UserIdNumber,
		@FK_CashBox,
		@ProgramPart,
		@TerminalName,
		GETDATE()
	)
	
	Set @AUDIT_LOG_TRANSACTION_ID = SCOPE_IDENTITY()
	

	INSERT INTO dbo.AUDIT_LOG_DATA
	(
		AUDIT_LOG_TRANSACTION_ID,
		PRIMARY_KEY_DATA,
		COL_NAME,
		OLD_VALUE_LONG,
		DATA_TYPE
		, KEY1
	)
	SELECT
		@AUDIT_LOG_TRANSACTION_ID,
		convert(nvarchar(1500), IsNull('[ReservationConfLineNumber]='+CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0), '[ReservationConfLineNumber] Is Null')),
		'ReservationConfLineNumber',
		CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0),
		'A'
		,  CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0))
	FROM deleted OLD
	WHERE
		OLD.[ReservationConfLineNumber] Is Not Null

	INSERT INTO dbo.AUDIT_LOG_DATA
	(
		AUDIT_LOG_TRANSACTION_ID,
		PRIMARY_KEY_DATA,
		COL_NAME,
		OLD_VALUE_LONG,
		DATA_TYPE
		, KEY1
	)
	SELECT
		@AUDIT_LOG_TRANSACTION_ID,
		convert(nvarchar(1500), IsNull('[ReservationConfLineNumber]='+CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0), '[ReservationConfLineNumber] Is Null')),
		'BookedConferenceRoomTypeNumber',
		CONVERT(nvarchar(4000), OLD.[BookedConferenceRoomTypeNumber], 0),
		'A'
		,  CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0))
	FROM deleted OLD
	WHERE
		OLD.[BookedConferenceRoomTypeNumber] Is Not Null

	INSERT INTO dbo.AUDIT_LOG_DATA
	(
		AUDIT_LOG_TRANSACTION_ID,
		PRIMARY_KEY_DATA,
		COL_NAME,
		OLD_VALUE_LONG,
		DATA_TYPE
		, KEY1
	)
	SELECT
		@AUDIT_LOG_TRANSACTION_ID,
		convert(nvarchar(1500), IsNull('[ReservationConfLineNumber]='+CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0), '[ReservationConfLineNumber] Is Null')),
		'ArrivalDate',
		CONVERT(nvarchar(4000), OLD.[ArrivalDate], 0),
		'A'
		,  CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0))
	FROM deleted OLD
	WHERE
		OLD.[ArrivalDate] Is Not Null

	INSERT INTO dbo.AUDIT_LOG_DATA
	(
		AUDIT_LOG_TRANSACTION_ID,
		PRIMARY_KEY_DATA,
		COL_NAME,
		OLD_VALUE_LONG,
		DATA_TYPE
		, KEY1
	)
	SELECT
		@AUDIT_LOG_TRANSACTION_ID,
		convert(nvarchar(1500), IsNull('[ReservationConfLineNumber]='+CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0), '[ReservationConfLineNumber] Is Null')),
		'ArrivalTime',
		CONVERT(nvarchar(4000), OLD.[ArrivalTime], 0),
		'A'
		,  CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0))
	FROM deleted OLD
	WHERE
		OLD.[ArrivalTime] Is Not Null

	INSERT INTO dbo.AUDIT_LOG_DATA
	(
		AUDIT_LOG_TRANSACTION_ID,
		PRIMARY_KEY_DATA,
		COL_NAME,
		OLD_VALUE_LONG,
		DATA_TYPE
		, KEY1
	)
	SELECT
		@AUDIT_LOG_TRANSACTION_ID,
		convert(nvarchar(1500), IsNull('[ReservationConfLineNumber]='+CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0), '[ReservationConfLineNumber] Is Null')),
		'DepartureDate',
		CONVERT(nvarchar(4000), OLD.[DepartureDate], 0),
		'A'
		,  CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0))
	FROM deleted OLD
	WHERE
		OLD.[DepartureDate] Is Not Null

	INSERT INTO dbo.AUDIT_LOG_DATA
	(
		AUDIT_LOG_TRANSACTION_ID,
		PRIMARY_KEY_DATA,
		COL_NAME,
		OLD_VALUE_LONG,
		DATA_TYPE
		, KEY1
	)
	SELECT
		@AUDIT_LOG_TRANSACTION_ID,
		convert(nvarchar(1500), IsNull('[ReservationConfLineNumber]='+CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0), '[ReservationConfLineNumber] Is Null')),
		'DepartureTime',
		CONVERT(nvarchar(4000), OLD.[DepartureTime], 0),
		'A'
		,  CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0))
	FROM deleted OLD
	WHERE
		OLD.[DepartureTime] Is Not Null

	INSERT INTO dbo.AUDIT_LOG_DATA
	(
		AUDIT_LOG_TRANSACTION_ID,
		PRIMARY_KEY_DATA,
		COL_NAME,
		OLD_VALUE_LONG,
		DATA_TYPE
		, KEY1
	)
	SELECT
		@AUDIT_LOG_TRANSACTION_ID,
		convert(nvarchar(1500), IsNull('[ReservationConfLineNumber]='+CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0), '[ReservationConfLineNumber] Is Null')),
		'ProductNumber',
		CONVERT(nvarchar(4000), OLD.[ProductNumber], 0),
		'A'
		,  CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0))
	FROM deleted OLD
	WHERE
		OLD.[ProductNumber] Is Not Null

	INSERT INTO dbo.AUDIT_LOG_DATA
	(
		AUDIT_LOG_TRANSACTION_ID,
		PRIMARY_KEY_DATA,
		COL_NAME,
		OLD_VALUE_LONG,
		DATA_TYPE
		, KEY1
	)
	SELECT
		@AUDIT_LOG_TRANSACTION_ID,
		convert(nvarchar(1500), IsNull('[ReservationConfLineNumber]='+CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0), '[ReservationConfLineNumber] Is Null')),
		'PackageNumber',
		CONVERT(nvarchar(4000), OLD.[PackageNumber], 0),
		'A'
		,  CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0))
	FROM deleted OLD
	WHERE
		OLD.[PackageNumber] Is Not Null

	INSERT INTO dbo.AUDIT_LOG_DATA
	(
		AUDIT_LOG_TRANSACTION_ID,
		PRIMARY_KEY_DATA,
		COL_NAME,
		OLD_VALUE_LONG,
		DATA_TYPE
		, KEY1
	)
	SELECT
		@AUDIT_LOG_TRANSACTION_ID,
		convert(nvarchar(1500), IsNull('[ReservationConfLineNumber]='+CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0), '[ReservationConfLineNumber] Is Null')),
		'Price',
		CONVERT(nvarchar(4000), OLD.[Price], 2),
		'A'
		,  CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0))
	FROM deleted OLD
	WHERE
		OLD.[Price] Is Not Null

	INSERT INTO dbo.AUDIT_LOG_DATA
	(
		AUDIT_LOG_TRANSACTION_ID,
		PRIMARY_KEY_DATA,
		COL_NAME,
		OLD_VALUE_LONG,
		DATA_TYPE
		, KEY1
	)
	SELECT
		@AUDIT_LOG_TRANSACTION_ID,
		convert(nvarchar(1500), IsNull('[ReservationConfLineNumber]='+CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0), '[ReservationConfLineNumber] Is Null')),
		'TotalPrice',
		CONVERT(nvarchar(4000), OLD.[TotalPrice], 2),
		'A'
		,  CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0))
	FROM deleted OLD
	WHERE
		OLD.[TotalPrice] Is Not Null

	INSERT INTO dbo.AUDIT_LOG_DATA
	(
		AUDIT_LOG_TRANSACTION_ID,
		PRIMARY_KEY_DATA,
		COL_NAME,
		OLD_VALUE_LONG,
		DATA_TYPE
		, KEY1
	)
	SELECT
		@AUDIT_LOG_TRANSACTION_ID,
		convert(nvarchar(1500), IsNull('[ReservationConfLineNumber]='+CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0), '[ReservationConfLineNumber] Is Null')),
		'PriceOverWritten',
		CONVERT(nvarchar(4000), OLD.[PriceOverWritten], 0),
		'A'
		,  CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0))
	FROM deleted OLD
	WHERE
		OLD.[PriceOverWritten] Is Not Null

	INSERT INTO dbo.AUDIT_LOG_DATA
	(
		AUDIT_LOG_TRANSACTION_ID,
		PRIMARY_KEY_DATA,
		COL_NAME,
		OLD_VALUE_LONG,
		DATA_TYPE
		, KEY1
	)
	SELECT
		@AUDIT_LOG_TRANSACTION_ID,
		convert(nvarchar(1500), IsNull('[ReservationConfLineNumber]='+CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0), '[ReservationConfLineNumber] Is Null')),
		'ConferenceRoomNumber',
		CONVERT(nvarchar(4000), OLD.[ConferenceRoomNumber], 0),
		'A'
		,  CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0))
	FROM deleted OLD
	WHERE
		OLD.[ConferenceRoomNumber] Is Not Null

	INSERT INTO dbo.AUDIT_LOG_DATA
	(
		AUDIT_LOG_TRANSACTION_ID,
		PRIMARY_KEY_DATA,
		COL_NAME,
		OLD_VALUE_LONG,
		DATA_TYPE
		, KEY1
	)
	SELECT
		@AUDIT_LOG_TRANSACTION_ID,
		convert(nvarchar(1500), IsNull('[ReservationConfLineNumber]='+CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0), '[ReservationConfLineNumber] Is Null')),
		'Adults',
		CONVERT(nvarchar(4000), OLD.[Adults], 0),
		'A'
		,  CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0))
	FROM deleted OLD
	WHERE
		OLD.[Adults] Is Not Null

	INSERT INTO dbo.AUDIT_LOG_DATA
	(
		AUDIT_LOG_TRANSACTION_ID,
		PRIMARY_KEY_DATA,
		COL_NAME,
		OLD_VALUE_LONG,
		DATA_TYPE
		, KEY1
	)
	SELECT
		@AUDIT_LOG_TRANSACTION_ID,
		convert(nvarchar(1500), IsNull('[ReservationConfLineNumber]='+CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0), '[ReservationConfLineNumber] Is Null')),
		'Children1',
		CONVERT(nvarchar(4000), OLD.[Children1], 0),
		'A'
		,  CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0))
	FROM deleted OLD
	WHERE
		OLD.[Children1] Is Not Null

	INSERT INTO dbo.AUDIT_LOG_DATA
	(
		AUDIT_LOG_TRANSACTION_ID,
		PRIMARY_KEY_DATA,
		COL_NAME,
		OLD_VALUE_LONG,
		DATA_TYPE
		, KEY1
	)
	SELECT
		@AUDIT_LOG_TRANSACTION_ID,
		convert(nvarchar(1500), IsNull('[ReservationConfLineNumber]='+CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0), '[ReservationConfLineNumber] Is Null')),
		'ReferenceNumber',
		CONVERT(nvarchar(4000), OLD.[ReferenceNumber], 0),
		'A'
		,  CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0))
	FROM deleted OLD
	WHERE
		OLD.[ReferenceNumber] Is Not Null

	INSERT INTO dbo.AUDIT_LOG_DATA
	(
		AUDIT_LOG_TRANSACTION_ID,
		PRIMARY_KEY_DATA,
		COL_NAME,
		OLD_VALUE_LONG,
		DATA_TYPE
		, KEY1
	)
	SELECT
		@AUDIT_LOG_TRANSACTION_ID,
		convert(nvarchar(1500), IsNull('[ReservationConfLineNumber]='+CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0), '[ReservationConfLineNumber] Is Null')),
		'TableBooking',
		CONVERT(nvarchar(4000), OLD.[TableBooking], 0),
		'A'
		,  CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0))
	FROM deleted OLD
	WHERE
		OLD.[TableBooking] Is Not Null

	INSERT INTO dbo.AUDIT_LOG_DATA
	(
		AUDIT_LOG_TRANSACTION_ID,
		PRIMARY_KEY_DATA,
		COL_NAME,
		OLD_VALUE_LONG,
		DATA_TYPE
		, KEY1
	)
	SELECT
		@AUDIT_LOG_TRANSACTION_ID,
		convert(nvarchar(1500), IsNull('[ReservationConfLineNumber]='+CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0), '[ReservationConfLineNumber] Is Null')),
		'TableStatus',
		CONVERT(nvarchar(4000), OLD.[TableStatus], 0),
		'A'
		,  CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0))
	FROM deleted OLD
	WHERE
		OLD.[TableStatus] Is Not Null

	INSERT INTO dbo.AUDIT_LOG_DATA
	(
		AUDIT_LOG_TRANSACTION_ID,
		PRIMARY_KEY_DATA,
		COL_NAME,
		OLD_VALUE_LONG,
		DATA_TYPE
		, KEY1
	)
	SELECT
		@AUDIT_LOG_TRANSACTION_ID,
		convert(nvarchar(1500), IsNull('[ReservationConfLineNumber]='+CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0), '[ReservationConfLineNumber] Is Null')),
		'GuestNo',
		CONVERT(nvarchar(4000), OLD.[GuestNo], 0),
		'A'
		,  CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0))
	FROM deleted OLD
	WHERE
		OLD.[GuestNo] Is Not Null

	INSERT INTO dbo.AUDIT_LOG_DATA
	(
		AUDIT_LOG_TRANSACTION_ID,
		PRIMARY_KEY_DATA,
		COL_NAME,
		OLD_VALUE_LONG,
		DATA_TYPE
		, KEY1
	)
	SELECT
		@AUDIT_LOG_TRANSACTION_ID,
		convert(nvarchar(1500), IsNull('[ReservationConfLineNumber]='+CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0), '[ReservationConfLineNumber] Is Null')),
		'Children2',
		CONVERT(nvarchar(4000), OLD.[Children2], 0),
		'A'
		,  CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0))
	FROM deleted OLD
	WHERE
		OLD.[Children2] Is Not Null

	INSERT INTO dbo.AUDIT_LOG_DATA
	(
		AUDIT_LOG_TRANSACTION_ID,
		PRIMARY_KEY_DATA,
		COL_NAME,
		OLD_VALUE_LONG,
		DATA_TYPE
		, KEY1
	)
	SELECT
		@AUDIT_LOG_TRANSACTION_ID,
		convert(nvarchar(1500), IsNull('[ReservationConfLineNumber]='+CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0), '[ReservationConfLineNumber] Is Null')),
		'PriceIsUserOverwritten',
		CONVERT(nvarchar(4000), OLD.[PriceIsUserOverwritten], 0),
		'A'
		,  CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[ReservationConfLineNumber], 0))
	FROM deleted OLD
	WHERE
		OLD.[PriceIsUserOverwritten] Is Not Null

	-- Lookup
	

	-- Restore @@IDENTITY Value
	DECLARE @maxprec AS varchar(2)
	SET @maxprec=CAST(@@MAX_PRECISION as varchar(2))
	EXEC('SELECT IDENTITY(decimal('+@maxprec+',0),'+@IDENTITY_SAVE+',1) id INTO #tmp')
END
